/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  MaybeAccount,
  MaybeEncodedAccount,
  assertAccountExists,
  assertAccountsExist,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import { Address } from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  combineCodec,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  mapEncoder,
} from '@solana/codecs';
import { DelegateRecordSeeds, findDelegateRecordPda } from '../pdas';
import {
  DelegateRole,
  DelegateRoleArgs,
  TmKey,
  getDelegateRoleDecoder,
  getDelegateRoleEncoder,
  getTmKeyDecoder,
  getTmKeyEncoder,
} from '../types';

export type DelegateRecord<TAddress extends string = string> = Account<
  DelegateRecordAccountData,
  TAddress
>;

export type MaybeDelegateRecord<TAddress extends string = string> =
  MaybeAccount<DelegateRecordAccountData, TAddress>;

export type DelegateRecordAccountData = {
  key: TmKey;
  role: DelegateRole;
  bump: number;
};

export type DelegateRecordAccountDataArgs = {
  role: DelegateRoleArgs;
  bump: number;
};

export function getDelegateRecordAccountDataEncoder(): Encoder<DelegateRecordAccountDataArgs> {
  return mapEncoder(
    getStructEncoder([
      ['key', getTmKeyEncoder()],
      ['role', getDelegateRoleEncoder()],
      ['bump', getU8Encoder()],
    ]),
    (value) => ({ ...value, key: TmKey.Delegate })
  );
}

export function getDelegateRecordAccountDataDecoder(): Decoder<DelegateRecordAccountData> {
  return getStructDecoder([
    ['key', getTmKeyDecoder()],
    ['role', getDelegateRoleDecoder()],
    ['bump', getU8Decoder()],
  ]);
}

export function getDelegateRecordAccountDataCodec(): Codec<
  DelegateRecordAccountDataArgs,
  DelegateRecordAccountData
> {
  return combineCodec(
    getDelegateRecordAccountDataEncoder(),
    getDelegateRecordAccountDataDecoder()
  );
}

export function decodeDelegateRecord<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): DelegateRecord<TAddress>;
export function decodeDelegateRecord<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeDelegateRecord<TAddress>;
export function decodeDelegateRecord<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
): DelegateRecord<TAddress> | MaybeDelegateRecord<TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getDelegateRecordAccountDataDecoder()
  );
}

export async function fetchDelegateRecord<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<DelegateRecord<TAddress>> {
  const maybeAccount = await fetchMaybeDelegateRecord(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeDelegateRecord<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeDelegateRecord<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeDelegateRecord(maybeAccount);
}

export async function fetchAllDelegateRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<DelegateRecord[]> {
  const maybeAccounts = await fetchAllMaybeDelegateRecord(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeDelegateRecord(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeDelegateRecord[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) =>
    decodeDelegateRecord(maybeAccount)
  );
}

export function getDelegateRecordSize(): number {
  return 282;
}

export async function fetchDelegateRecordFromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: DelegateRecordSeeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<DelegateRecord> {
  const maybeAccount = await fetchMaybeDelegateRecordFromSeeds(
    rpc,
    seeds,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeDelegateRecordFromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: DelegateRecordSeeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<MaybeDelegateRecord> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findDelegateRecordPda(seeds, { programAddress });
  return fetchMaybeDelegateRecord(rpc, address, fetchConfig);
}
