/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  MaybeAccount,
  MaybeEncodedAccount,
  assertAccountExists,
  assertAccountsExist,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import { Address } from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  Option,
  OptionOrNullable,
  combineCodec,
  getOptionDecoder,
  getOptionEncoder,
  getStructDecoder,
  getStructEncoder,
  getU64Decoder,
  getU64Encoder,
  mapEncoder,
} from '@solana/codecs';
import { MasterEditionV2Seeds, findMasterEditionV2Pda } from '../pdas';
import { TmKey, getTmKeyDecoder, getTmKeyEncoder } from '../types';

export type MasterEditionV2<TAddress extends string = string> = Account<
  MasterEditionV2AccountData,
  TAddress
>;

export type MaybeMasterEditionV2<TAddress extends string = string> =
  MaybeAccount<MasterEditionV2AccountData, TAddress>;

export type MasterEditionV2AccountData = {
  key: TmKey;
  supply: bigint;
  maxSupply: Option<bigint>;
};

export type MasterEditionV2AccountDataArgs = {
  supply: number | bigint;
  maxSupply: OptionOrNullable<number | bigint>;
};

export function getMasterEditionV2AccountDataEncoder(): Encoder<MasterEditionV2AccountDataArgs> {
  return mapEncoder(
    getStructEncoder([
      ['key', getTmKeyEncoder()],
      ['supply', getU64Encoder()],
      ['maxSupply', getOptionEncoder(getU64Encoder())],
    ]),
    (value) => ({ ...value, key: TmKey.MasterEditionV2 })
  );
}

export function getMasterEditionV2AccountDataDecoder(): Decoder<MasterEditionV2AccountData> {
  return getStructDecoder([
    ['key', getTmKeyDecoder()],
    ['supply', getU64Decoder()],
    ['maxSupply', getOptionDecoder(getU64Decoder())],
  ]);
}

export function getMasterEditionV2AccountDataCodec(): Codec<
  MasterEditionV2AccountDataArgs,
  MasterEditionV2AccountData
> {
  return combineCodec(
    getMasterEditionV2AccountDataEncoder(),
    getMasterEditionV2AccountDataDecoder()
  );
}

export function decodeMasterEditionV2<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): MasterEditionV2<TAddress>;
export function decodeMasterEditionV2<TAddress extends string = string>(
  encodedAccount: MaybeEncodedAccount<TAddress>
): MaybeMasterEditionV2<TAddress>;
export function decodeMasterEditionV2<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress> | MaybeEncodedAccount<TAddress>
): MasterEditionV2<TAddress> | MaybeMasterEditionV2<TAddress> {
  return decodeAccount(
    encodedAccount as MaybeEncodedAccount<TAddress>,
    getMasterEditionV2AccountDataDecoder()
  );
}

export async function fetchMasterEditionV2<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MasterEditionV2<TAddress>> {
  const maybeAccount = await fetchMaybeMasterEditionV2(rpc, address, config);
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeMasterEditionV2<
  TAddress extends string = string
>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<MaybeMasterEditionV2<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return decodeMasterEditionV2(maybeAccount);
}

export async function fetchAllMasterEditionV2(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MasterEditionV2[]> {
  const maybeAccounts = await fetchAllMaybeMasterEditionV2(
    rpc,
    addresses,
    config
  );
  assertAccountsExist(maybeAccounts);
  return maybeAccounts;
}

export async function fetchAllMaybeMasterEditionV2(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<MaybeMasterEditionV2[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) =>
    decodeMasterEditionV2(maybeAccount)
  );
}

export function getMasterEditionV2Size(): number {
  return 282;
}

export async function fetchMasterEditionV2FromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: MasterEditionV2Seeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<MasterEditionV2> {
  const maybeAccount = await fetchMaybeMasterEditionV2FromSeeds(
    rpc,
    seeds,
    config
  );
  assertAccountExists(maybeAccount);
  return maybeAccount;
}

export async function fetchMaybeMasterEditionV2FromSeeds(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  seeds: MasterEditionV2Seeds,
  config: FetchAccountConfig & { programAddress?: Address } = {}
): Promise<MaybeMasterEditionV2> {
  const { programAddress, ...fetchConfig } = config;
  const [address] = await findMasterEditionV2Pda(seeds, { programAddress });
  return fetchMaybeMasterEditionV2(rpc, address, fetchConfig);
}
