/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  Context,
  OptionOrNullable,
  Pda,
  PublicKey,
  RpcAccount,
  RpcGetAccountOptions,
  RpcGetAccountsOptions,
  assertAccountExists,
  deserializeAccount,
  gpaBuilder,
  publicKey as toPublicKey,
} from '@metaplex-foundation/umi';
import {
  array,
  option,
  publicKey as publicKeySerializer,
  u64,
} from '@metaplex-foundation/umi/serializers';
import {
  ReservationListV1AccountData,
  getReservationListV1AccountDataSerializer,
} from '../../hooked';
import {
  ReservationV1Args,
  TmKey,
  TmKeyArgs,
  getReservationV1Serializer,
  getTmKeySerializer,
} from '../types';

export type ReservationListV1 = Account<ReservationListV1AccountData>;

export function deserializeReservationListV1(
  rawAccount: RpcAccount
): ReservationListV1 {
  return deserializeAccount(
    rawAccount,
    getReservationListV1AccountDataSerializer()
  );
}

export async function fetchReservationListV1(
  context: Pick<Context, 'rpc'>,
  publicKey: PublicKey | Pda,
  options?: RpcGetAccountOptions
): Promise<ReservationListV1> {
  const maybeAccount = await context.rpc.getAccount(
    toPublicKey(publicKey, false),
    options
  );
  assertAccountExists(maybeAccount, 'ReservationListV1');
  return deserializeReservationListV1(maybeAccount);
}

export async function safeFetchReservationListV1(
  context: Pick<Context, 'rpc'>,
  publicKey: PublicKey | Pda,
  options?: RpcGetAccountOptions
): Promise<ReservationListV1 | null> {
  const maybeAccount = await context.rpc.getAccount(
    toPublicKey(publicKey, false),
    options
  );
  return maybeAccount.exists
    ? deserializeReservationListV1(maybeAccount)
    : null;
}

export async function fetchAllReservationListV1(
  context: Pick<Context, 'rpc'>,
  publicKeys: Array<PublicKey | Pda>,
  options?: RpcGetAccountsOptions
): Promise<ReservationListV1[]> {
  const maybeAccounts = await context.rpc.getAccounts(
    publicKeys.map((key) => toPublicKey(key, false)),
    options
  );
  return maybeAccounts.map((maybeAccount) => {
    assertAccountExists(maybeAccount, 'ReservationListV1');
    return deserializeReservationListV1(maybeAccount);
  });
}

export async function safeFetchAllReservationListV1(
  context: Pick<Context, 'rpc'>,
  publicKeys: Array<PublicKey | Pda>,
  options?: RpcGetAccountsOptions
): Promise<ReservationListV1[]> {
  const maybeAccounts = await context.rpc.getAccounts(
    publicKeys.map((key) => toPublicKey(key, false)),
    options
  );
  return maybeAccounts
    .filter((maybeAccount) => maybeAccount.exists)
    .map((maybeAccount) =>
      deserializeReservationListV1(maybeAccount as RpcAccount)
    );
}

export function getReservationListV1GpaBuilder(
  context: Pick<Context, 'rpc' | 'programs'>
) {
  const programId = context.programs.getPublicKey(
    'mplTokenMetadata',
    'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'
  );
  return gpaBuilder(context, programId)
    .registerFields<{
      key: TmKeyArgs;
      masterEdition: PublicKey;
      supplySnapshot: OptionOrNullable<number | bigint>;
      reservations: Array<ReservationV1Args>;
    }>({
      key: [0, getTmKeySerializer()],
      masterEdition: [1, publicKeySerializer()],
      supplySnapshot: [33, option(u64())],
      reservations: [null, array(getReservationV1Serializer())],
    })
    .deserializeUsing<ReservationListV1>((account) =>
      deserializeReservationListV1(account)
    )
    .whereField('key', TmKey.ReservationListV1);
}
