/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Context,
  Option,
  OptionOrNullable,
  Pda,
  PublicKey,
  Signer,
  TransactionBuilder,
  transactionBuilder,
} from '@metaplex-foundation/umi';
import {
  Serializer,
  array,
  mapSerializer,
  option,
  struct,
  u64,
  u8,
} from '@metaplex-foundation/umi/serializers';
import {
  ResolvedAccount,
  ResolvedAccountsWithIndices,
  getAccountMetasAndSigners,
} from '../shared';
import {
  Reservation,
  ReservationArgs,
  getReservationSerializer,
} from '../types';

// Accounts.
export type DeprecatedSetReservationListInstructionAccounts = {
  /** Master Edition V1 key (pda of ['metadata', program id, mint id, 'edition']) */
  masterEdition: PublicKey | Pda;
  /** PDA for ReservationList of ['metadata', program id, master edition key, 'reservation', resource-key] */
  reservationList: PublicKey | Pda;
  /** The resource you tied the reservation list too */
  resource: Signer;
};

// Data.
export type DeprecatedSetReservationListInstructionData = {
  discriminator: number;
  reservations: Array<Reservation>;
  totalReservationSpots: Option<bigint>;
  offset: bigint;
  totalSpotOffset: bigint;
};

export type DeprecatedSetReservationListInstructionDataArgs = {
  reservations: Array<ReservationArgs>;
  totalReservationSpots: OptionOrNullable<number | bigint>;
  offset: number | bigint;
  totalSpotOffset: number | bigint;
};

export function getDeprecatedSetReservationListInstructionDataSerializer(): Serializer<
  DeprecatedSetReservationListInstructionDataArgs,
  DeprecatedSetReservationListInstructionData
> {
  return mapSerializer<
    DeprecatedSetReservationListInstructionDataArgs,
    any,
    DeprecatedSetReservationListInstructionData
  >(
    struct<DeprecatedSetReservationListInstructionData>(
      [
        ['discriminator', u8()],
        ['reservations', array(getReservationSerializer())],
        ['totalReservationSpots', option(u64())],
        ['offset', u64()],
        ['totalSpotOffset', u64()],
      ],
      { description: 'DeprecatedSetReservationListInstructionData' }
    ),
    (value) => ({ ...value, discriminator: 5 })
  ) as Serializer<
    DeprecatedSetReservationListInstructionDataArgs,
    DeprecatedSetReservationListInstructionData
  >;
}

// Args.
export type DeprecatedSetReservationListInstructionArgs =
  DeprecatedSetReservationListInstructionDataArgs;

// Instruction.
export function deprecatedSetReservationList(
  context: Pick<Context, 'programs'>,
  input: DeprecatedSetReservationListInstructionAccounts &
    DeprecatedSetReservationListInstructionArgs
): TransactionBuilder {
  // Program ID.
  const programId = context.programs.getPublicKey(
    'mplTokenMetadata',
    'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'
  );

  // Accounts.
  const resolvedAccounts = {
    masterEdition: {
      index: 0,
      isWritable: true as boolean,
      value: input.masterEdition ?? null,
    },
    reservationList: {
      index: 1,
      isWritable: true as boolean,
      value: input.reservationList ?? null,
    },
    resource: {
      index: 2,
      isWritable: false as boolean,
      value: input.resource ?? null,
    },
  } satisfies ResolvedAccountsWithIndices;

  // Arguments.
  const resolvedArgs: DeprecatedSetReservationListInstructionArgs = {
    ...input,
  };

  // Accounts in order.
  const orderedAccounts: ResolvedAccount[] = Object.values(
    resolvedAccounts
  ).sort((a, b) => a.index - b.index);

  // Keys and Signers.
  const [keys, signers] = getAccountMetasAndSigners(
    orderedAccounts,
    'programId',
    programId
  );

  // Data.
  const data =
    getDeprecatedSetReservationListInstructionDataSerializer().serialize(
      resolvedArgs as DeprecatedSetReservationListInstructionDataArgs
    );

  // Bytes Created On Chain.
  const bytesCreatedOnChain = 0;

  return transactionBuilder([
    { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
  ]);
}
